Bug 904798

Summary: Review Request: sfact - Converts 3D model into G-Code for RepRap
Product: [Fedora] Fedora Reporter: Miro Hrončok <mhroncok>
Component: Package ReviewAssignee: T.C. Hollingsworth <tchollingsworth>
Status: CLOSED CURRENTRELEASE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: notting, package-review, tchollingsworth
Target Milestone: ---Flags: tchollingsworth: fedora‑review+
limburgher: fedora‑cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2013-02-12 23:34:36 EST Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:

Description Miro Hrončok 2013-01-27 10:31:59 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/sfact.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/sfact-0.0-1.20121114git89e1e76.fc18.src.rpm

Description:

SFACT is the new Skeinforge, it is a tool chain composed of Python scripts
that converts your 3D model into G-Code instructions for RepRap.

Fedora Account System Username: churchyard
Comment 1 Miro Hrončok 2013-01-28 06:54:19 EST
Upstream included https://github.com/ahmetcemturan/SFACT/blob/master/COPYING
Comment 2 T.C. Hollingsworth 2013-01-28 21:16:08 EST
This fails to build.

Executing(%doc): /bin/sh -e /var/tmp/rpm-tmp.R5Z0G4
+ umask 022
+ cd /builddir/build/BUILD
+ cd SFACT-89e1e76d35899ad21516a2facc75df274c5550e1
+ DOCDIR=/builddir/build/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc19.x86_64/usr/share/doc/sfact-0.0
+ export DOCDIR
+ /usr/bin/mkdir -p /builddir/build/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc19.x86_64/usr/share/doc/sfact-0.0
+ cp -pr 'SFACT /builddir/build/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc19.x86_64/usr/share/doc/sfact-0.0'
cp: missing destination file operand after 'SFACT /builddir/build/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc19.x86_64/usr/share/doc/sfact-0.0'
Try 'cp --help' for more information.
error: Bad exit status from /var/tmp/rpm-tmp.R5Z0G4 (%doc)
RPM build errors:
    Bad exit status from /var/tmp/rpm-tmp.R5Z0G4 (%doc)
Child return code was: 1
EXCEPTION: Command failed. See logs for output.
Comment 3 Miro Hrončok 2013-01-28 21:26:52 EST
Executing(%doc): /bin/sh -e /var/tmp/rpm-tmp.yZSoAa
+ umask 022
+ cd /home/churchyard/rpmbuild/BUILD
+ cd SFACT-89e1e76d35899ad21516a2facc75df274c5550e1
+ DOCDIR=/home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64/usr/share/doc/sfact-doc-0.0
+ export DOCDIR
+ /usr/bin/mkdir -p /home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64/usr/share/doc/sfact-doc-0.0
+ cp -pr documentation /home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64/usr/share/doc/sfact-doc-0.0
+ exit 0
Provides: sfact-doc = 0.0-1.20121114git89e1e76.fc18
Requires(rpmlib): rpmlib(CompressedFileNames) <= 3.0.4-1 rpmlib(FileDigests) <= 4.6.0-1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
Checking for unpackaged file(s): /usr/lib/rpm/check-files /home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64
Wrote: /home/churchyard/rpmbuild/SRPMS/sfact-0.0-1.20121114git89e1e76.fc18.src.rpm
Wrote: /home/churchyard/rpmbuild/RPMS/noarch/sfact-0.0-1.20121114git89e1e76.fc18.noarch.rpm
Wrote: /home/churchyard/rpmbuild/RPMS/noarch/sfact-doc-0.0-1.20121114git89e1e76.fc18.noarch.rpm
Executing(%clean): /bin/sh -e /var/tmp/rpm-tmp.6kUbqb
+ umask 022
+ cd /home/churchyard/rpmbuild/BUILD
+ cd SFACT-89e1e76d35899ad21516a2facc75df274c5550e1
+ /usr/bin/rm -rf /home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64
+ exit 0


Don't know, what happened, but I've reuploaded SRPM in case something went wrong. Could you please (redownload and) try again?
Comment 4 Miro Hrončok 2013-01-29 07:59:24 EST
Ah, wrong section.

Executing(%doc): /bin/sh -e /var/tmp/rpm-tmp.b4eTZC
+ umask 022
+ cd /home/churchyard/rpmbuild/BUILD
+ cd SFACT-89e1e76d35899ad21516a2facc75df274c5550e1
+ DOCDIR=/home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64/usr/share/doc/sfact-0.0
+ export DOCDIR
+ /usr/bin/mkdir -p /home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64/usr/share/doc/sfact-0.0
+ cp -pr 'SFACT Readme.txt' /home/churchyard/rpmbuild/BUILDROOT/sfact-0.0-1.20121114git89e1e76.fc18.x86_64/usr/share/doc/sfact-0.0
+ exit 0

I thing, that there is a problem with space in filename, maybe (but I don't know why) this

%doc SFACT\ Readme.txt

does work as escaping the space at my machine, but not at yours?
Comment 5 T.C. Hollingsworth 2013-01-29 14:26:05 EST
Okay, the difference here is that fedora-review mockbuilds in rawhide, and rawhide has some changes in %doc handling.

See:
http://article.gmane.org/gmane.linux.redhat.fedora.devel/173464
http://rpm.org/ticket/858

Please use one of the described solutions to ensure your package builds on both Rawhide and whichever Fedora releases you want to support.
Comment 7 Miro Hrončok 2013-01-29 16:59:32 EST
I have read the e-mail about this when it was posted, but I've forgot it.
Comment 8 T.C. Hollingsworth 2013-01-31 22:18:08 EST
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed

Resolution: NEEDS WORK

==== Issues ====

[!]: rpmlint output is not clean.

     See the rpmlint section at the bottom of the review for details.

[!]: Fedora-specific launcher scripts do not use `exec`.

     Please use `exec` so the bash process doesn't stay around forever, or
     launch in Python like you did with Cura, if possible.

==== Things to Consider ====

[ ]: This is a fork of the 'skeinforge' package in Fedora.

     While such forks are permissible in Fedora (c.f. LibreOffice, MATE,
     MariaDB, et. al.), please do consider working with the other upstreams
     that use skeinforge to instead use this package, if it really does confer
     benefits.

[ ]: No %check section is present.

     The tarball included does not appear to contain tests, but please do make
     sure upstream does not provide them seperately.

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package contains no bundled libraries.
[x]: Changelog in prescribed format.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Sources contain only permissible code or content.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install if there is
     such a file.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Package complies to the Packaging Guidelines
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "*No copyright* GPL (v3 or later)", "*No copyright* GPL (v2 or later)",
     "GPL (v2 or later)", "GPL (v3 or later)", "Unknown or generated". 5 files
     have unknown license. Detailed output of licensecheck in
     /home/fedora/patches/904798-sfact/licensecheck.txt

Seems to be false positive like skeinforge was.

[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named using only allowed ASCII characters.
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: Package do not use a name that already exist
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package installs properly.
[x]: Package is not relocatable.
[x]: Requires correct, justified where necessary.
[x]: CheckResultdir
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file is legible and written in American English.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Package contains BR: python2-devel or python3-devel
[-]: Binary eggs must be removed in %prep
[x]: Python eggs must not download any dependencies during the build process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX / PatchY prefixed with %{name}.
[x]: SourceX is a working URL.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.
[-]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: sfact-0.0-2.20130128gitbc56c68.fc19.noarch.rpm
          sfact-doc-0.0-2.20130128gitbc56c68.fc19.noarch.rpm
          sfact-0.0-2.20130128gitbc56c68.fc19.src.rpm
sfact.noarch: W: incoherent-version-in-changelog 0.0-2.20130128gitbc56c688 ['0.0-2.20130128gitbc56c68.fc19', '0.0-2.20130128gitbc56c68']

Please fix.

sfact.noarch: W: no-manual-page-for-binary sfact
sfact.noarch: W: no-manual-page-for-binary sfact-craft

Consider asking upstream to include a manpage or writing one yourself.

sfact.src: W: strange-permission sfact 0755L
sfact.src: W: strange-permission sfact-craft 0755L

False positive; these should be executable.

3 packages and 0 specfiles checked; 0 errors, 5 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint sfact sfact-doc
sfact.noarch: W: incoherent-version-in-changelog 0.0-2.20130128gitbc56c688 ['0.0-2.20130128gitbc56c68.fc19', '0.0-2.20130128gitbc56c68']
sfact.noarch: W: no-manual-page-for-binary sfact
sfact.noarch: W: no-manual-page-for-binary sfact-craft
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'

All addressed above.

Requires
--------
sfact-0.0-2.20130128gitbc56c68.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    /bin/bash
    /bin/sh
    /usr/bin/python
    pypy
    python(abi) = 2.7
    python2
    tkinter

sfact-doc-0.0-2.20130128gitbc56c68.fc19.noarch.rpm (rpmlib, GLIBC filtered):
    
    sfact = 0.0-2.20130128gitbc56c68.fc19



Provides
--------
sfact-0.0-2.20130128gitbc56c68.fc19.noarch.rpm:
    
    sfact = 0.0-2.20130128gitbc56c68.fc19

sfact-doc-0.0-2.20130128gitbc56c68.fc19.noarch.rpm:
    
    sfact-doc = 0.0-2.20130128gitbc56c68.fc19



MD5-sum check
-------------
https://github.com/ahmetcemturan/SFACT/archive/bc56c6882269fb14e36bc7bd6582c19be6114c06/sfact-0.0-bc56c68.tar.gz :
  CHECKSUM(SHA256) this package     : f65ea8bebb3cc7f9f1083a123e8339ef37028388c5e2e7e8a9dd39408379715c
  CHECKSUM(SHA256) upstream package : f65ea8bebb3cc7f9f1083a123e8339ef37028388c5e2e7e8a9dd39408379715c


Generated by fedora-review 0.3.1 (b71abc1) last change: 2012-10-16
Buildroot used: fedora-rawhide-x86_64
Command line :/usr/bin/fedora-review -b904798
Comment 9 Miro Hrončok 2013-02-01 16:32:30 EST
Spec URL: https://raw.github.com/hroncok/SPECS/master/sfact.spec
SRPM URL: https://github.com/downloads/hroncok/SPECS/sfact-0.0-3.20130128gitbc56c68.fc18.src.rpm

- Corrected version in %%changelog
- Use exec in launchers
Comment 10 T.C. Hollingsworth 2013-02-01 16:45:52 EST
% rpmlint SRPMS/sfact-0.0-3.20130128gitbc56c68.fc18.src.rpm 
sfact.src: W: strange-permission sfact 0755L
sfact.src: W: strange-permission sfact-craft 0755L
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

Changelog warning gone.

% cat SOURCES/sfact
#!/bin/bash
exec python /usr/lib/python2.7/site-packages/sfact/sfact.py "$@"
exit $?
% cat SOURCES/sfact-craft 
#!/bin/bash
echo "Using pypy, you can ignore Tkinter warnings"
exec pypy /usr/lib/python2.7/site-packages/sfact/skeinforge_application/skeinforge_utilities/skeinforge_craft.py "$@"
exit $?

The `exit $?` lines are useless now that exec is used, but harmless.

This package is APPROVED.
Comment 11 Miro Hrončok 2013-02-01 19:33:24 EST
New Package SCM Request
=======================
Package Name: sfact
Short Description: Converts 3D model into G-Code for RepRap
Owners: churchyard
Branches: f17 f18
Comment 12 Jon Ciesla 2013-02-04 09:04:36 EST
Git done (by process-git-requests).
Comment 13 Fedora Update System 2013-02-04 10:53:42 EST
sfact-0.0-3.20130128gitbc56c68.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/sfact-0.0-3.20130128gitbc56c68.fc17
Comment 14 Fedora Update System 2013-02-04 10:56:25 EST
sfact-0.0-3.20130128gitbc56c68.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/sfact-0.0-3.20130128gitbc56c68.fc18
Comment 15 Fedora Update System 2013-02-04 21:57:11 EST
sfact-0.0-3.20130128gitbc56c68.fc18 has been pushed to the Fedora 18 testing repository.
Comment 16 Fedora Update System 2013-02-12 23:34:38 EST
sfact-0.0-3.20130128gitbc56c68.fc17 has been pushed to the Fedora 17 stable repository.
Comment 17 Fedora Update System 2013-02-12 23:37:55 EST
sfact-0.0-3.20130128gitbc56c68.fc18 has been pushed to the Fedora 18 stable repository.